CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes
csl::FancyFMInstrument Class Reference

FancyFMInstrument - FM with vibrato (with AR-envelope), attack chiff (filtered noise with AR-envelope), and random freq. drift and ampl. swell envelopes. More...

`#include <BasicFMInstrument.h>`

Inheritance diagram for csl::FancyFMInstrument:

List of all members.

## Public Member Functions
| FancyFMInstrument ()
| Constructor.
| ~FancyFMInstrument ()
void | setParameter (unsigned selector, int argc, void **argv, const char *types)
| Plug functions.
void | playOSC (int argc, void **argv, const char *types)
void | playMIDI (float dur, int chan, int key, int vel)
| These are the additional UGens of the DSP graph (i.e., the FM instrument)
void | parseArgs (int argc, void **argv, const char *types)
| Play functions.
void | playNote (float dur=1, float ampl=1, float c_fr=110, float m_fr=110, float ind=1, float pos=0, float att=0.1, float dec=0.1, float sus=0.5, float rel=0.1, float i_att=0.1, float i_dec=0.1, float i_sus=0.5, float i_rel=0.1)
virtual void | playNote (int argc, void **argv, const char *types)
| Play a note (subclasses refine)
UnitGenerator * | graph ()
| Accessors.
UGenMap * | genMap ()
| my UGen graph
UGenVector * | envelopes ()
| the map of ugens in the graph by name
const string | name ()
| the vector of envelopes to query or trigger
UnitGenerator * | genNamed (string name)
| answer my name answer the number of channels
AccessorVector | getAccessors ()
| Accessor management.
unsigned | numAccessors ()
| answer the accessor vector
virtual void | nextBuffer (Buffer &outputBuffer) throw (CException)
| set a named parameter
virtual void | nextBuffer (Buffer &outputBuffer, unsigned outBufNum) throw (CException)
| really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times
virtual bool | isActive ()
| Envelope query and re-trigger.
virtual void | play ()
virtual void | release ()
unsigned | frameRate ()
void | setFrameRate (unsigned rate)
| get/set the receiver's frame rate
virtual unsigned | numChannels ()
void | setNumChannels (unsigned ch)
| get/set the receiver's number of outputs
BufferCopyPolicy | copyPolicy ()
void | setCopyPolicy (BufferCopyPolicy ch)
| get/set the receiver's buffer copy policy
virtual bool | isFixed ()
| query whether I'm fixed (StaticVariable overrides this)
void | addOutput (UnitGenerator *ugen)
| add to or return the UGen vector of outputs
void | removeOutput (UnitGenerator *ugen)
UGenVector | outputs ()
virtual unsigned | numOutputs ()
bool | checkFanOut (Buffer &outputBuffer) throw (CException)
| check for fan-out and copy previous buffer; return true if fanning out
void | handleFanOut (Buffer &outputBuffer) throw (CException)
virtual void | setValue (sample theValue)
| set/get the value (not allowed in the abstract, useful for static values)
virtual sample | value ()
virtual void | dump ()
| pretty-print the receiver
virtual void | trigger ()
void | attachObserver (Observer *)
| (possibly notify obersvers on my death)
void | detachObserver (Observer *)
void | changed (void *argument)
| this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map
virtual int | evaluate (void *argument)

## Public Attributes
Envelope | mVibEnv
| vibrato envelope
ADSR | mChiffEnv
| attack-chiff envelope
Osc | mVibrato
| sine oscillator for vibrato
WhiteNoise | mChiff
| chiff noise
Butter | mChFilter
| chiff filter
Freeverb | mReverb
ADSR | mAEnv
ADSR | mIEnv
| amplitude & modulation index envelopes
Osc | mCar
Osc | mMod
| 2 sine oscillators, carrier and modulator
Panner | mPanner
| stereo panner

## Protected Member Functions
void | zeroBuffer (Buffer &outputBuffer, unsigned outBufNum)
| utility method to zero out an outputBuffer

## Protected Attributes
UnitGenerator * | mGraph
| Caches.
string | mName
| my name
UGenMap | mUGens
| the map of ugens in the graph by name
UGenVector | mEnvelopes
| the vector of envelopes to query or trigger
AccessorVector | mAccessors
| the accessor vector
unsigned | mFrameRate
| trigger ignored here
unsigned | mNumChannels
| my "expected" number of output channels
BufferCopyPolicy | mCopyPolicy
| the policy I use if asked for more or fewer channels
UGenVector | mOutputs
| the vector of my output UGens
unsigned | mNumOutputs
| the number of outputs
Buffer * | mOutputCache
| my past output ring buffer (only used in case of fan-out)
unsigned | mSequence
| the highest-seen buffer seq number

## Detailed Description

FancyFMInstrument - FM with vibrato (with AR-envelope), attack chiff (filtered noise with AR-envelope), and random freq. drift and ampl. swell envelopes.

Definition at line 67 of file BasicFMInstrument.h.

## Constructor & Destructor Documentation

FancyFMInstrument::FancyFMInstrument | ( |  | ) |

Constructor.

Definition at line 227 of file BasicFMInstrument.cpp.

References BASE_FREQ, csl::FMInstrument::mCar, mChFilter, mChiff, mChiffEnv, csl::Instrument::mEnvelopes, csl::FMInstrument::mMod, csl::Instrument::mName, mReverb, csl::Instrument::mUGens, mVibEnv, mVibrato, and csl::Scalable::setScale().

FancyFMInstrument::~FancyFMInstrument | ( |  | ) |

Definition at line 257 of file BasicFMInstrument.cpp.

## Member Function Documentation

void FancyFMInstrument::setParameter | ( | unsigned | selector,
|  | int | argc,
|  | void ** | argv,
|  | const char * | types
| ) |  |
| virtual

Plug functions.

Reimplemented from csl::FMInstrument.

Definition at line 259 of file BasicFMInstrument.cpp.

References csl::kLogError, csl::logMsg(), mChiffEnv, csl::FMInstrument::mMod, mVibEnv, mVibrato, set_c_freq_f, set_chiff_amt_f, set_duration_f, set_vib_depth_f, csl::Envelope::setDuration(), csl::ADSR::setDuration(), and csl::Scalable::setScale().

Referenced by testFancyFMInstrument().

void FancyFMInstrument::playOSC | ( | int | argc,
|  | void ** | argv,
|  | const char * | types
| ) |  |
| virtual

Reimplemented from csl::FMInstrument.

Definition at line 285 of file BasicFMInstrument.cpp.

References csl::fRandZ(), mChiffEnv, csl::FMInstrument::mMod, mVibrato, csl::FMInstrument::parseArgs(), csl::Instrument::play(), csl::ADSR::setAttack(), and csl::ADSR::setDecay().

void FancyFMInstrument::playMIDI | ( | float | dur,
|  | int | chan,
|  | int | key,
|  | int | vel
| ) |  |
| virtual

These are the additional UGens of the DSP graph (i.e., the FM instrument)

Reimplemented from csl::FMInstrument.

Definition at line 298 of file BasicFMInstrument.cpp.

References csl::fRandZ(), csl::keyToFreq(), csl::FMInstrument::mAEnv, mChiffEnv, csl::FMInstrument::mIEnv, csl::FMInstrument::mMod, mVibrato, csl::Instrument::play(), csl::Envelope::scaleValues(), csl::ADSR::setAttack(), csl::ADSR::setDecay(), and csl::ADSR::setDuration().

void FMInstrument::parseArgs | ( | int | argc,
|  | void ** | argv,
|  | const char * | types
| ) |  |
| inherited

Play functions.

Definition at line 130 of file BasicFMInstrument.cpp.

References csl::kLogError, csl::logMsg(), csl::FMInstrument::mAEnv, csl::FMInstrument::mIEnv, csl::FMInstrument::mMod, csl::FMInstrument::mPanner, csl::Envelope::scaleValues(), csl::ADSR::setAttack(), csl::ADSR::setDecay(), csl::ADSR::setDuration(), csl::Panner::setPosition(), csl::ADSR::setRelease(), csl::Scalable::setScale(), and csl::ADSR::setSustain().

Referenced by csl::FMInstrument::playOSC(), and playOSC().

void FMInstrument::playNote | ( | float | dur = `1`,
|  | float | ampl = `1`,
|  | float | c_fr = `110`,
|  | float | m_fr = `110`,
|  | float | ind = `1`,
|  | float | pos = `0`,
|  | float | att = `0.1`,
|  | float | dec = `0.1`,
|  | float | sus = `0.5`,
|  | float | rel = `0.1`,
|  | float | i_att = `0.1`,
|  | float | i_dec = `0.1`,
|  | float | i_sus = `0.5`,
|  | float | i_rel = `0.1`
| ) |  |
| inherited

Definition at line 184 of file BasicFMInstrument.cpp.

References csl::FMInstrument::mAEnv, csl::FMInstrument::mIEnv, csl::FMInstrument::mMod, csl::FMInstrument::mPanner, csl::Instrument::play(), csl::Envelope::scaleValues(), csl::ADSR::setAttack(), csl::ADSR::setDecay(), csl::ADSR::setDuration(), csl::Panner::setPosition(), csl::ADSR::setRelease(), and csl::ADSR::setSustain().

virtual void csl::Instrument::playNote | ( | int | argc,
|  | void ** | argv,
|  | const char * | types
| ) |  |
| inline virtual inherited

Play a note (subclasses refine)

Definition at line 82 of file Instrument.h.

UnitGenerator* csl::Instrument::graph | ( |  | ) |
| inline inherited

Accessors.

Definition at line 63 of file Instrument.h.

References csl::Instrument::mGraph.

UGenMap* csl::Instrument::genMap | ( |  | ) |
| inline inherited

my UGen graph

Definition at line 64 of file Instrument.h.

References csl::Instrument::mUGens.

Referenced by csl::Instrument::Instrument().

UGenVector* csl::Instrument::envelopes | ( |  | ) |
| inline inherited

the map of ugens in the graph by name

Definition at line 65 of file Instrument.h.

References csl::Instrument::mEnvelopes.

Referenced by csl::Instrument::Instrument().

const string csl::Instrument::name | ( |  | ) |
| inline inherited

the vector of envelopes to query or trigger

Definition at line 67 of file Instrument.h.

References csl::Instrument::mName.

Referenced by setupOSCInstrLibrary().

UnitGenerator * Instrument::genNamed | ( | string | name | ) |
| inherited

answer my name answer the number of channels

get a UGen from the graph

Definition at line 47 of file Instrument.cpp.

References csl::Instrument::mUGens.

AccessorVector csl::Instrument::getAccessors | ( |  | ) |
| inline inherited

Accessor management.

Definition at line 72 of file Instrument.h.

References csl::Instrument::mAccessors.

Referenced by csl::Instrument::Instrument(), and setupOSCInstrLibrary().

unsigned csl::Instrument::numAccessors | ( |  | ) |
| inline inherited

answer the accessor vector

Definition at line 73 of file Instrument.h.

References csl::Instrument::mAccessors.

Referenced by setupOSCInstrLibrary().

void Instrument::nextBuffer | ( | Buffer & | outputBuffer | ) | throw (CException)
| virtual inherited

set a named parameter

get a UGen from the graph

Sample creation

Reimplemented from csl::UnitGenerator.

Definition at line 41 of file Instrument.cpp.

void UnitGenerator::nextBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  | throw (CException)
| virtual inherited

really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times

Reimplemented in csl::Joiner, csl::Splitter, csl::FanOut, SAFliter, csl::RandEnvelope, csl::Moog, csl::AmbisonicDecoder, csl::Impulse, csl::Square, csl::AmbisonicEncoder, csl::Sawtooth, csl::FSine, csl::MulOp, csl::Envelope, csl::Sine, csl::DynamicVariable, csl::Filter, csl::AmbisonicRotator, csl::CompOrCacheOscillator, csl::BufferStream, csl::AddOp, csl::FIR, csl::WavetableOscillator, csl::PinkNoise, csl::VBAP, csl::RtpReceiver, csl::SineAsScaled, csl::SpatialSource, csl::LineSegment, csl::StaticVariable, csl::AmbisonicMixer, csl::WhiteNoise, csl::SineAsPhased, csl::SpatialPanner, csl::Window, csl::RingBufferTap, csl::BinaryOp, csl::Freeverb, csl::KarplusString, csl::RtpSender, csl::Clipper, csl::Lorenz, csl::SimpleSine, csl::DistanceSimulator, and csl::WaveShaper.

Definition at line 605 of file CSL_Core.cpp.

bool Instrument::isActive | ( |  | ) |
| virtual inherited

Envelope query and re-trigger.

Reimplemented from csl::UnitGenerator.

Definition at line 57 of file Instrument.cpp.

References FALSE, csl::UnitGenerator::isActive(), csl::Instrument::mEnvelopes, csl::Instrument::mGraph, and TRUE.

Referenced by csl::MIDIPlayer::start().

void Instrument::play | ( |  | ) |
| virtual inherited

Reimplemented in csl::SampleBankInstrument, and csl::SndFileInstrument.

Definition at line 70 of file Instrument.cpp.

References csl::Instrument::mEnvelopes, and csl::UnitGenerator::trigger().

Referenced by csl::AdditiveInstrument::playMIDI(), csl::FMInstrument::playMIDI(), playMIDI(), csl::AdditiveInstrument::playNote(), csl::FMInstrument::playNote(), playNote(), csl::AdditiveInstrument::playOSC(), csl::FMInstrument::playOSC(), playOSC(), testFancyFMInstrument(), and testFMInstrument().

void Instrument::release | ( |  | ) |
| virtual inherited

Definition at line 76 of file Instrument.cpp.

References csl::Instrument::mEnvelopes, and csl::UnitGenerator::trigger().

unsigned csl::UnitGenerator::frameRate | ( |  | ) |
| inline inherited

Definition at line 225 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), csl::SoundCue::dump(), csl::Filter::init(), csl::SndFileInstrument::playNote(), and csl::SndFileInstrument::playOSC().

void csl::UnitGenerator::setFrameRate | ( | unsigned | rate | ) |
| inline inherited

get/set the receiver's frame rate

Definition at line 226 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by m3_header().

virtual unsigned csl::UnitGenerator::numChannels | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::Splitter, and csl::Stereoverb.

Definition at line 228 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::AmbisonicMixer::addInput(), csl::BlockResizer::BlockResizer(), csl::Port::checkBuffer(), csl::Effect::Effect(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), m3_output(), csl::Mixer::nextBuffer(), and csl::SpatialSource::SpatialSource().

void csl::UnitGenerator::setNumChannels | ( | unsigned | ch | ) |
| inline inherited

get/set the receiver's number of outputs

Definition at line 229 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::BinauralPanner::BinauralPanner(), m3_output(), csl::Spatializer::Spatializer(), csl::VBAP::speakerLayoutChanged(), and csl::VBAP::VBAP().

BufferCopyPolicy csl::UnitGenerator::copyPolicy | ( |  | ) |
| inline inherited

Definition at line 231 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

void csl::UnitGenerator::setCopyPolicy | ( | BufferCopyPolicy | ch | ) |
| inline inherited

get/set the receiver's buffer copy policy

Definition at line 232 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

Referenced by csl::AmbisonicPanner::AmbisonicPanner(), csl::BinauralPanner::BinauralPanner(), csl::AmbisonicUnitGenerator::initOrder(), csl::Noise::Noise(), csl::PinkNoise::PinkNoise(), csl::Spatializer::Spatializer(), and csl::VBAP::VBAP().

virtual bool csl::UnitGenerator::isFixed | ( |  | ) |
| inline virtual inherited

query whether I'm fixed (StaticVariable overrides this)

Reimplemented in csl::StaticVariable, and csl::BinaryOp.

Definition at line 247 of file CSL_Core.h.

void UnitGenerator::addOutput | ( | UnitGenerator * | ugen | ) |
| inherited

add to or return the UGen vector of outputs

Definition at line 520 of file CSL_Core.cpp.

References csl::Buffer::allocateBuffers(), csl::CGestalt::maxBufferFrames(), csl::UnitGenerator::mNumOutputs, csl::UnitGenerator::mOutputCache, and csl::UnitGenerator::mOutputs.

Referenced by csl::Mixer::addInput(), csl::Controllable::addInput(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicEncoder::setInput(), and csl::IO::setRoot().

void UnitGenerator::removeOutput | ( | UnitGenerator * | ugen | ) |
| inherited

Definition at line 530 of file CSL_Core.cpp.

References csl::UnitGenerator::mNumOutputs, and csl::UnitGenerator::mOutputs.

Referenced by csl::IO::clearRoot(), csl::AmbisonicEncoder::setInput(), csl::AmbisonicDecoder::~AmbisonicDecoder(), and csl::AmbisonicRotator::~AmbisonicRotator().

UGenVector csl::UnitGenerator::outputs | ( |  | ) |
| inline inherited

Definition at line 253 of file CSL_Core.h.

References csl::UnitGenerator::mOutputs.

virtual unsigned csl::UnitGenerator::numOutputs | ( |  | ) |
| inline virtual inherited

Definition at line 254 of file CSL_Core.h.

References csl::UnitGenerator::mNumOutputs.

bool UnitGenerator::checkFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

check for fan-out and copy previous buffer; return true if fanning out

Definition at line 549 of file CSL_Core.cpp.

void UnitGenerator::handleFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

Definition at line 563 of file CSL_Core.cpp.

References csl_max.

virtual void csl::UnitGenerator::setValue | ( | sample | theValue | ) |
| inline virtual inherited

set/get the value (not allowed in the abstract, useful for static values)

Reimplemented in csl::DynamicVariable, and csl::StaticVariable.

Definition at line 260 of file CSL_Core.h.

virtual sample csl::UnitGenerator::value | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::StaticVariable.

Definition at line 261 of file CSL_Core.h.

void UnitGenerator::dump | ( | void |  | ) |
| virtual inherited

pretty-print the receiver

Reimplemented in csl::RandEnvelope, csl::SumOfSines, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::Filter, csl::VBAP, csl::SineAsScaled, csl::LineSegment, csl::SpatialSource, csl::SineAsPhased, csl::Mixer, csl::Window, csl::KarplusString, csl::Oscillator, csl::AmbisonicPanner, csl::BinaryOp, csl::Lorenz, csl::Clipper, csl::CASoundFile, and csl::Noise.

Definition at line 543 of file CSL_Core.cpp.

References csl::logMsg(), and csl::UnitGenerator::mOutputs.

Referenced by csl::Port::dump(), dumpTest(), and testSimpleSines().

virtual void csl::UnitGenerator::trigger | ( | void |  | ) |
| inline virtual inherited

Reimplemented in csl::Joiner, csl::Effect, csl::RandEnvelope, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::LineSegment, and csl::KarplusString.

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Instrument::play(), csl::Instrument::release(), and csl::Port::trigger().

void UnitGenerator::zeroBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  |
| protected inherited

utility method to zero out an outputBuffer

Definition at line 513 of file CSL_Core.cpp.

References csl::Buffer::mMonoBufferByteSize, and csl::Buffer::monoBuffer().

void Model::attachObserver | ( | Observer * | o | ) |
| inherited

(possibly notify obersvers on my death)

register/remove observers

Definition at line 491 of file CGestalt.cpp.

References csl::logMsg(), csl::Observer::mKey, and csl::Observer::mPeriod.

Referenced by csl::SpatialPanner::setSpeakerLayout().

void Model::detachObserver | ( | Observer * | o | ) |
| inherited

Definition at line 507 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::~SpatialPanner().

void Model::changed | ( | void * | argument | ) |
| inherited

this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map

Definition at line 529 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpeakerLayout::addSpeaker(), csl::MIDIIn::handleIncomingMidiMessage(), and csl::SpeakerLayout::setDefaultSpeakerLayout().

virtual int csl::Model::evaluate | ( | void * | argument | ) |
| inline virtual inherited

Reimplemented in csl::MIDIIn.

Definition at line 259 of file CGestalt.h.

## Member Data Documentation

Envelope csl::FancyFMInstrument::mVibEnv

vibrato envelope

Definition at line 76 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument(), and setParameter().

ADSR csl::FancyFMInstrument::mChiffEnv

attack-chiff envelope

Definition at line 77 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument(), playMIDI(), playOSC(), and setParameter().

Osc csl::FancyFMInstrument::mVibrato

sine oscillator for vibrato

Definition at line 78 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument(), playMIDI(), playOSC(), and setParameter().

WhiteNoise csl::FancyFMInstrument::mChiff

chiff noise

Definition at line 79 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument().

Butter csl::FancyFMInstrument::mChFilter

chiff filter

Definition at line 80 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument().

Freeverb csl::FancyFMInstrument::mReverb

Definition at line 81 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument().

ADSR csl::FMInstrument::mAEnv
| inherited

Definition at line 58 of file BasicFMInstrument.h.

Referenced by csl::FMInstrument::FMInstrument(), csl::FMInstrument::parseArgs(), csl::FMInstrument::playMIDI(), playMIDI(), csl::FMInstrument::playNote(), and csl::FMInstrument::setParameter().

ADSR csl::FMInstrument::mIEnv
| inherited

amplitude & modulation index envelopes

Definition at line 58 of file BasicFMInstrument.h.

Referenced by csl::FMInstrument::FMInstrument(), csl::FMInstrument::parseArgs(), csl::FMInstrument::playMIDI(), playMIDI(), csl::FMInstrument::playNote(), and csl::FMInstrument::setParameter().

Osc csl::FMInstrument::mCar
| inherited

Definition at line 59 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument(), and csl::FMInstrument::FMInstrument().

Osc csl::FMInstrument::mMod
| inherited

2 sine oscillators, carrier and modulator

Definition at line 59 of file BasicFMInstrument.h.

Referenced by FancyFMInstrument(), csl::FMInstrument::FMInstrument(), csl::FMInstrument::parseArgs(), csl::FMInstrument::playMIDI(), playMIDI(), csl::FMInstrument::playNote(), playOSC(), csl::FMInstrument::setParameter(), and setParameter().

Panner csl::FMInstrument::mPanner
| inherited

stereo panner

Definition at line 60 of file BasicFMInstrument.h.

Referenced by csl::FMInstrument::FMInstrument(), csl::FMInstrument::parseArgs(), csl::FMInstrument::playNote(), and csl::FMInstrument::setParameter().

UnitGenerator* csl::Instrument::mGraph
| protected inherited

Caches.

my UGen graph

Definition at line 87 of file Instrument.h.

Referenced by csl::FMInstrument::FMInstrument(), csl::Instrument::graph(), csl::AdditiveInstrument::init(), csl::SndFileInstrument::initialize(), and csl::Instrument::isActive().

string csl::Instrument::mName
| protected inherited

my name

Definition at line 88 of file Instrument.h.

Referenced by FancyFMInstrument(), csl::FMInstrument::FMInstrument(), csl::AdditiveInstrument::init(), csl::SndFileInstrument::initialize(), and csl::Instrument::name().

UGenMap csl::Instrument::mUGens
| protected inherited

the map of ugens in the graph by name

Definition at line 89 of file Instrument.h.

Referenced by FancyFMInstrument(), csl::FMInstrument::FMInstrument(), csl::Instrument::genMap(), csl::Instrument::genNamed(), csl::AdditiveInstrument::init(), csl::SndFileInstrument::initialize(), and csl::Instrument::Instrument().

UGenVector csl::Instrument::mEnvelopes
| protected inherited

the vector of envelopes to query or trigger

Definition at line 90 of file Instrument.h.

Referenced by csl::Instrument::envelopes(), FancyFMInstrument(), csl::FMInstrument::FMInstrument(), csl::AdditiveInstrument::init(), csl::Instrument::Instrument(), csl::Instrument::isActive(), csl::Instrument::play(), and csl::Instrument::release().

AccessorVector csl::Instrument::mAccessors
| protected inherited

the accessor vector

Definition at line 91 of file Instrument.h.

Referenced by csl::FMInstrument::FMInstrument(), csl::Instrument::getAccessors(), csl::AdditiveInstrument::init(), csl::SndFileInstrument::initialize(), csl::Instrument::Instrument(), and csl::Instrument::numAccessors().

unsigned csl::UnitGenerator::mFrameRate
| protected inherited

trigger ignored here

the frame rate – initialized to be the default by the constructor

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::RtpSender::createRtpSession(), csl::RtpReceiver::createRtpSession(), csl::Lorenz::dump(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::Filter::init(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::RandEnvelope::nextSegment(), csl::SquareBL::nextWaveInto(), csl::SumOfSines::nextWaveInto(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::DelayLine::setDelayTime(), csl::UnitGenerator::setFrameRate(), csl::Abst_SoundFile::setStartSec(), csl::Abst_SoundFile::setStopSec(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Moog::setupCoeffs(), and csl::DecodedFile::writeBuffer().

unsigned csl::UnitGenerator::mNumChannels
| protected inherited

my "expected" number of output channels

Definition at line 268 of file CSL_Core.h.

Referenced by csl::AmbisonicMixer::addInput(), csl::Mixer::allocateOpBuffer(), csl::AmbisonicDecoder::asProjection(), csl::AmbisonicDecoder::asPseudoInverse(), csl::BlockResizer::BlockResizer(), csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::checkBuffer(), csl::DecodedFile::checkBufferStack(), csl::FMInstrument::FMInstrument(), csl::GrainPlayer::GrainPlayer(), csl::AdditiveInstrument::init(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::AmbisonicMixer::initialize(), csl::SndFileInstrument::initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicEncoder::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicUnitGenerator::initOrder(), csl::RemoteStream::initPacket(), csl::Joiner::isActive(), csl::AmbisonicDecoder::makeInPhase(), csl::AmbisonicDecoder::makeMaxRE(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), csl::Mixer::Mixer(), csl::UnitGenerator::numChannels(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::Panner::Panner(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RemoteStream::RemoteStream(), csl::UnitGenerator::setNumChannels(), csl::WavetableOscillator::setWaveform(), csl::Joiner::trigger(), csl::DecodedFile::writeBuffer(), and csl::AmbisonicRotator::~AmbisonicRotator().

BufferCopyPolicy csl::UnitGenerator::mCopyPolicy
| protected inherited

the policy I use if asked for more or fewer channels

Definition at line 269 of file CSL_Core.h.

Referenced by csl::UnitGenerator::copyPolicy(), and csl::UnitGenerator::setCopyPolicy().

UGenVector csl::UnitGenerator::mOutputs
| protected inherited

the vector of my output UGens

Definition at line 270 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::dump(), csl::UnitGenerator::outputs(), and csl::UnitGenerator::removeOutput().

unsigned csl::UnitGenerator::mNumOutputs
| protected inherited

the number of outputs

Definition at line 271 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::numOutputs(), and csl::UnitGenerator::removeOutput().

Buffer* csl::UnitGenerator::mOutputCache
| protected inherited

my past output ring buffer (only used in case of fan-out)

Definition at line 272 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput().

unsigned csl::UnitGenerator::mSequence
| protected inherited

the highest-seen buffer seq number

Definition at line 273 of file CSL_Core.h.

The documentation for this class was generated from the following files:

- CSL/Instruments/BasicFMInstrument.h
- CSL/Instruments/BasicFMInstrument.cpp